import networkx as nx
from itertools import combinations

class Utils:

	def __init__(self):
		self.G = nx.Graph()

	def unique(self,a):
		""" return the list with duplicate elements removed """
		return list(set(a))

	def intersect(self,a, b):
		""" return the intersection of two lists """
		return list(set(a) & set(b))

	def union(self,a, b):
		""" return the union of two lists """
		return list(set(a) | set(b))

	# a: ( clusterID:string , FIfreq:int , FI:set() )
	# b: ( clusterID:string , FIfreq:int , FI:set() )
	def jaccard( self , a_raw , b_raw ):
		score = 0.0
		a = a_raw[1]
		b = b_raw[1]
		len_inter = len( a.intersection(b) )
		if len_inter>0:
			score = len_inter / float(len( a.union(b) ))
		return [ score , a_raw[0] , b_raw[0] ]



	# ( cID_a , cID_b , FI_a:set() , FI_b:set() )
	# x [  0  ,   1   ,     2      ,      3     ]
	def jaccard_idx( self , raw ):
		score = 0.0
		a = raw[2]
		b = raw[3]
		len_inter = len( a.intersection(b) )
		if len_inter>0:
			score = len_inter / float(len( a.union(b) ))
		return [ score , raw[0] , raw[1] ]

	def addCompleteSubGraph(self,terms):
		G=self.G
		# <addnode> #
		for i in terms:
			G.add_node(i)
		# </addnode> #

		# <addedge> #
		edges = combinations(terms, 2)
		for n in edges:
			n1=n[0]
			n2=n[1]
			if G.has_edge(n1,n2):
				G[n1][n2]['weight']+=1
			else: G.add_edge(n1,n2,weight=1)
		self.G = G