# sudo apt-get install graphviz libgraphviz-dev pkg-config
# pip install flask flask_wtf py4j numpy findspark networkx asyncio aiohttp pygraphviz

import findspark
findspark.init()
from pyspark.mllib.fpm import FPGrowth
from InterUnion import Utils
import simplejson as json
import os
import datetime
import pprint
import itertools
import time
from itertools import combinations
import networkx as nx

def lineal_comparisons( years ):
	D = {}
	pairs = []
	# print( years )
	# print("")
	for i in range(len(years)):
		try:
			temmmp = [years[i],years[i+1]]
			pairs.append( temmmp )
			idx = "_".join(list(map(str,temmmp)))
			D[idx] = True
		except:
			break
			pass
	# print( pairs )
	return pairs, D



class Period:
	def __init__(self , some_sc=False , period=1990 , minsetsize=3 , minsupp=0.0001 , numpart=10 , minfsetsize=4):
		# self.sc = SparkContext("local","simple app")
		self.sc = some_sc
		self.utls = Utils()
		self.abs_path = "/datasets/PubMed2014/Full_pearson-filter/YYYY.json.txt"
		self.idx = period
		self.minsetsize = minsetsize

		self.minsupp = minsupp
		self.numpart = numpart

		self.minfsetsize = minfsetsize

		self.FI = ""
		self.FI_c = 0
		self.P_c = 0
		self.K = set()
		self.TF = ""

	def test2( self ):
		sc = self.sc
		logData = sc.textFile( "/var/log/syslog" )
		numAs = logData.filter(lambda s: 'a' in s).count()
		numBs = logData.filter(lambda s: 'b' in s).count()
		print("Lines with a: %i, lines with b: %i" % (numAs, numBs))
		print("- - - - - - - - ")
		a=[1,4,3,5]
		a = sc.parallelize(a)
		print ( a )
		print ( a.take(2) )

	def get_json( self , the_year ):
		return self.abs_path.replace( "YYYY" , str(the_year) )


	def _count( self , year ):
		sc = self.sc
		docs = sc.textFile( self.get_json(year) )
		print ( docs.count() )




	# # # # = = FI  = = = # # # 
	# # # # = = ( x[0]<FreqItemset> , x[1] ) = = = # # # 
	# # # # = = = ( "freq"|"items" , cID ) = = = # # # 
	# # # # = = = (   supp|FI , cID ) = = = # # # 
	# - - - - - - - - - - - - - - - - - - - - - # 
	# # # # = = K = = = # # # 
	# # # = = =    PRI             = = = # # # 
	# # # = = = (  x[0]  , x[1] ) = = = # # # 
	# # # = = = ( itemID , clusters<resultiterable> ) = = = # # # 
	def FPG_unit( self , WL=[] ):

		sc = self.sc

		sexecm = True
		if sc==False: 
			print("solo-mode:  creating sc")
			sc = SparkContext("local","simple app") # # simple-exec mode # #
		else:
			sexecm = False

		year = self.idx
		print( "FP",year )
		minsetsize = self.minsetsize
		minsupp = self.minsupp
		numpart = self.numpart
		minfsetsize = self.minfsetsize

		P_path = self.get_json(year)
		P = sc.textFile( P_path ).map( lambda line: [int(x) for x in line.strip().split(' ')] )
		P = P.filter( lambda x: len(x)>=minsetsize ).map( lambda x : (x[0] , x[1:],) )

		# T = data.map( lambda line: [int(x) for x in line.strip().split(' ')][1:] ).filter( lambda x: len(x)>=minsetsize )

		# data = sc.parallelize( P )
		# T = data.map( lambda x : x[1] ).filter( lambda x: len(x)>=minsetsize )


		# Psub = P.join( WL ).map(lambda x: (x[0],x[1][0]))
		T = P.join( WL ).map(lambda x: x[1][0] )

		t_i = time.time() ##
		self.P_c = T.count()
		t_f = time.time() ##
		T_t = "{0:.3f}".format((t_f - t_i)) +"[s]" ##

		# # saving term frequencies
		# self.TF = T.flatMap(lambda xs: [x for x in xs]).map(lambda x: (x, 1))
		# .reduceByKey( lambda v1,v2: v1+v2 ).sortBy(lambda x: x[1])

		model = FPGrowth.train(T, minSupport=minsupp, numPartitions=numpart)

		# # # # = = [ Extracting Frequent Itemsets ]  = = = # # # 
		# - - - - - - - - - - - - - - - - - - - - - # 
		# # # # - - INPUT: FPmodel+T  - - - # # # 
		# - - - - - - - - - - - - - - - - - - - - - # 
		# self.FI = model.freqItemsets().filter(lambda x: len(x.items)>=minfsetsize and x.freq>=2)
		# .sortBy(lambda x: x.freq , ascending=False).zipWithIndex().map( lambda x: ( x[1] , x[0][0] , x[0][1]  )  ).persist()

		t_i = time.time() ##
		self.FI = model.freqItemsets().filter(lambda x: len(x.items)>=minfsetsize and x.freq>=2)
		self.FI = self.FI.sortBy(lambda x: x.freq , ascending=False).zipWithIndex().map( lambda x : (x[1],x[0]) ).persist()
		#.filter(lambda x: x[1]<=100).map( lambda x: ( x[1] , x[0][0] , x[0][1]  )  ).persist()
		# - - - - - - - - - - - - - - - - - - - - - # 
		# # # # = = OUTPUT: FI  = = = # # # 
		# - - - - - - - - - - - - - - - - - - - - - # 
		# # # # = = ( x[0]<FreqItemset> , x[1] ) = = = # # # 
		# # # # = = = ( "freq"|"items" , cID ) = = = # # # 
		# # # # = = = (   supp|FI , cID ) = = = # # # 
		# - - - - - - - - - - - - - - - - - - - - - # 
		# # # # = = [ / Extracting Frequent Itemsets ]  = = = # # # 

		self.FI_c = self.FI.count()

		t_f = time.time() ##
		FI_t = "{0:.3f}".format((t_f - t_i)) +"[s]" ##

		# # print("")
		# # print("")
		# # print("----FI----",year)
		# for i in self.FI.collect():
		# 	print( i )
		

		# # # # = = [ Getting {item,cluster*} ]  = = = # # # 
		# - - - - - - - - - - - - - - - - - - - - - # 
		# # # - - - INPUT: FI  - - - # # # 
		# - - - - - - - - - - - - - - - - - - - - - # 
		# # # # = = ( x[0]<FreqItemset> , x[1] ) = = = # # # 
		# # # # = = = ( x[0].freq<int>|items<{}> , cID ) = = = # # # 
		self.K = self.FI.map( lambda x : [ (item_,x[0]) for item_ in x[1].items ] ).flatMap(lambda x: x).groupByKey()
		# - - - - - - - - - - - - - - - - - - - - - # 
		# # # - - - OUTPUT: K  - - - # # # 
		# - - - - - - - - - - - - - - - - - - - - - # 
		# # # = = =    PRI             = = = # # # 
		# # # = = = (  x[0]  , x[1] ) = = = # # # 
		# # # = = = ( itemID , clusters<resultiterable> ) = = = # # # 
		# - - - - - - - - - - - - - - - - - - - - - # 
		# # # # = = [ / Getting {item,cluster*} ]  = = = # # # 



		# # print("")
		# # print("")
		# # print( "K:", self.K ,year)
		# ress = self.K.collect()
		# # ress = set( ress )
		# for i in ress:
		# 	print( i )

		# print( T.take(3) )
		print( "\t\t\t|T|"," -> ",self.P_c , "\t",T_t )
		print( "\t\t\t|FI|"," -> ",self.FI_c , "\t",FI_t )
		print("")
		return self.P_c , self.FI_c


		if sexecm:
			print("solo-mode:  destroying sc")
			sc.stop() # # simple-exec mode # #
		

class Phylo:

	def __init__(self , t=[] , minK=4 , minJ=0.0 , spark_context=False , ncores=10 ):
		self.sc = spark_context
		self.utls = Utils()
		# self.years = t #list( range( t[0], t[1]+1 ) ) # combinations(self.years, 2)
		self.p = {
			"elemfrequency": { "type": int , "value": 1 },
			"from_": { "type": int , "value": -1 },
			"to_": { "type": int , "value": -1 },
			"minfpgsupp": { "type": float , "value": 0.0001 },
			"minfsetsupp": { "type": int , "value": 2 },
			"minfsetsize": { "type": int , "value": 4 },
			"minsetdistance": { "type":float , "value": 0.0 },
			"mram": { "type": int , "value": 40 },
			"ncores": { "type": int , "value": 20 },
			"query": { "type": str , "value": "" }
		}

		self.WL = False
		self.years = False
		self.pairs = False # 
		self.pairsD = False #lineal_comparisons( self.years )

		self.minsupp = 0.0001
		self.partitions = int(ncores)
		self.yearsD = {}
		self.minK = minK
		self.phylomm = {}
		self.minjacc = minJ
		# self.KxC = {}


	def get_atts( self , scn ):
		d = {
			"sc" : scn ,
			"years" : self.years ,
			"pairsD" : self.pairsD ,
			"minsupp" : self.minsupp ,
			"partitions" : self.partitions ,
			"yearsD" : sorted(list(self.yearsD.keys())) ,
			"minK" : self.minK ,
			"phylomm" : [ (key,value["count"]) for key,value in self.phylomm.items() ] ,
			"minjacc" : self.minjacc ,
		}
		return d


	def FPG_chain( self , t=[] , WL=[] ):
		N = self.yearsD
		K = self.minK

		if len(WL)>0:
			WL = self.sc.parallelize( WL ).map( lambda x: (int(x) , 1) )
		else:
			WL = self.WL

		Distribution = {}
		for y in t :
			period_ = Period( some_sc=self.sc , period=y , numpart=self.partitions )
			n_pubs , n_fis = period_.FPG_unit( WL )
			N[ y ] = period_
			Distribution[ y ] = {
				"|FIs|": n_fis,
				"|T|": n_pubs
			}
		self.WL = WL
		years = list(  map( int , (sorted(Distribution.keys())) )  )
		pairs, pairsD = lineal_comparisons( years )

		return Distribution , years , pairs , pairsD


	def temp_matching(self , thepairs):
		print( "temp_matching:",thepairs )
		jacc_distances = []
		for y in thepairs:
			idx = sorted( [y[0] , y[1]] )
			idx = "_".join(list(map(str,idx)))
			if idx not in self.phylomm:
				if self.yearsD[y[0]].FI_c>0 and self.yearsD[y[1]].FI_c>0:
					# print("")
					print( "\t",y[0] ,"x", y[1],"...")
					rdd_ = self.cartesian_product_idx( y[0] , y[1] ).persist()
					rdd_c = rdd_.count()
					self.phylomm[ idx ] =  { 
						"rdd_" : rdd_,
						"count": rdd_c
					}
					print( "\t\t",self.phylomm[ idx ]["count"])
				else:
					self.phylomm[ idx ] =  { 
						"rdd_" : None,
						"count": 0
					}


	def get_opossites( self , found_distances=[] , filter_s = {} ):

		print( "AAAAAAH" )
		print( filter_s )
		data = {}

		Nodes = {}
		period_nodes = {}
		for i in found_distances:
			idA = i[1]
			idB = i[2]
			Nodes[idA] = True
			Nodes[idB] = True

		for i in Nodes:
			nA = list(map( int , i.split("c")))

			if nA[0] not in period_nodes:
				period_nodes[ nA[0] ] = {}
			if nA[1] not in period_nodes[ nA[0] ]:
				period_nodes[ nA[0] ][ nA[1] ] = True

		for i in period_nodes:
			tuppps = []
			for ngram in period_nodes[i]:
				tuppps.append( ( ngram , 1 , ) )
			period_nodes[i] = tuppps

		for y in period_nodes:
			clusters = self.sc.parallelize( period_nodes[y] )
			R = self.yearsD[y].FI.join( clusters ).map(lambda x : [x[0] , list(x[1][0].items) , x[1][0].freq ] )
			if "minfsetsupp" in filter_s:
				R = R.filter( lambda x : x[2]>=filter_s["minfsetsupp"] )
			if "minfsetsize" in filter_s:
				R = R.filter( lambda x : len(x[1])>=filter_s["minfsetsize"] )
			RR = R.collect()
			# pprint.pprint( RR )
			for i in RR:
				cID = str(y)+"c"+str(i[0])
				if cID not in data:
					data[ cID ] = {
						"period": y , 
						"items": i[1] , 
						"supp": i[2]
					}

		return data



	def filter_jaccard(self , filter_s = {} ):

		jacc_min = filter_s["jacc_min"]
		f__ = filter_s

		# print("\tin filter_jaccard!!")
		rname = datetime.datetime.now().isoformat()+""
		thepath = "OUTPUTS/"+rname
		from output_2json import PhyloMaker
		lll = PhyloMaker(thepath , thepath , 0.0)


		print("DEBUGGING!!!")
		print( sorted(list( self.phylomm.keys() )) )
		found_distances = []
		for idx in self.phylomm:
			if self.phylomm[idx]["count"] > 0:
				found_distances += self.phylomm[idx]["rdd_"].filter( lambda x: x[0]>=jacc_min ).collect()
				# for i in found_distances:
				# 	print(i)
		print( "\t",jacc_min,"-> |JACCARD|:",len(found_distances) )

		timerange = [ 1982 , 2014 ]
		phylojson, Parents = lll.export_phylo( liens=found_distances , T=timerange , jacc_min=jacc_min )

		nodes_md = self.get_opossites( found_distances , filter_s )

		nB2A = {}
		nA2B = {}
		NodesD_i2s = {}
		NodesD_s2i = {}
		NodesC = 0

		for IDA_o in sorted(nodes_md.keys()):
			IDA_s = "A_"+str(IDA_o)
			if IDA_s not in NodesD_s2i:
				NodesC += 1
				NodesD_i2s[ NodesC ] = {
					"ID_o": IDA_o,
					"ID_s": IDA_s,
					"ID_i": NodesC
				}
				NodesD_s2i[ IDA_s ] = NodesC


			items_ = {}
			# print( IDA_o )
			for ii in nodes_md[IDA_o]["items"]:
				IDB_s = "B_"+str( ii )
				if IDB_s not in NodesD_s2i:
					NodesC += 1
					NodesD_i2s[ NodesC ] = {
						"ID_o": ii,
						"ID_s": IDB_s,
						"ID_i": NodesC
					}
					NodesD_s2i[ IDB_s ] = NodesC
				IDB_i =  NodesD_s2i[ IDB_s ]
				items_[ IDB_i ] = True
			# print("\t",sorted(items_))
			# print("")
			nA2B[ NodesD_s2i[ IDA_s ] ] = items_

			for i in items_:
				if i not in nB2A:
					nB2A[i] =  {}
				nB2A[i][ NodesD_s2i[ IDA_s ] ] = True



		# ETAGES = {}
		# print("")
		# print("PARENTS!!:")
		# for p in sorted( Parents.keys() ):
		# 	TO_MERGE = nx.Graph()
		# 	p_items = sorted(nA2B[ NodesD_s2i[ "A_"+str(p) ] ])
		# 	print(p ,":", p_items)
		# 	p_children = sorted(Parents[p])
		# 	p_children_D = {}
		# 	for j in p_children:
		# 		child_items = nA2B[ NodesD_s2i[ "A_"+str(j) ] ]
		# 		print("\t",j ,":", sorted(child_items) )
		# 		if j in Parents:
		# 			j_children = Parents[j]

		# 			if j not in p_children_D:
		# 				p_children_D[ j ] = set( j_children )

		# 	if len(p_children_D)>0:
		# 		for i in p_children_D:
		# 			TO_MERGE.add_node( i )
		# 		p_j_children_pairs = combinations(p_children_D.keys(), 2)
		# 		for cc in p_j_children_pairs:
		# 			CID1 = cc[0]
		# 			CID2 = cc[1]
		# 			if p_children_D[ CID1 ] == p_children_D[ CID2 ]:
		# 				print( "\t\t\tsame content:",CID1,CID2 )
		# 				TO_MERGE.add_edge( CID1 , CID2 ) 
		# 		print("")
		# 		h = nx.connected_components(TO_MERGE)  
		# 		for ss in h:
		# 			if len(ss)>1:
		# 				print("\t\t\t",ss)
		# 				# print(ss)
		# 				merge_this = {}
		# 				for ss_i in ss:
		# 					print("\t\t\t\t",ss_i)
		# 					# merge_this.union( p_children_D[ ss_i ] )
		# 					elems = p_children_D[ ss_i ]
		# 					for ll in elems:
		# 						merge_this[ ll ] = True
		# 				merge_this = set(merge_this.keys())
		# 				print("\t\t\t",merge_this )
		# 			print("")
		# 		print("")

		from n_partite_graph import nPartiteGraph
		bg = nPartiteGraph()
		graph_b = bg.BiGraph_2( nA2B , nB2A )
		GraphB = graph_b["G"]
		if GraphB.number_of_edges()==0:
			return { "nodes": [] , "links": [] }


		Nodes = []
		Links = []

		for n in GraphB.nodes_iter():
			# label = NodesD_i2s[ n ]["ID_s"]
			node = {
				"attributes":{},
				"r_id": NodesD_i2s[ n ]["ID_s"],
				"id": n,
				"label": str( NodesD_i2s[ n ]["ID_o"] ),
				"type": "mesh_term",
				"size": GraphB.degree(n)
			}
			Nodes.append(node)
			# print( node )

		# print("")
		# print("")
		# print(" - - - - ")
		# print(" - - - - ")
		# print(" - - - - ")
		# print("")
		# print("")

		C_liens = len( Links )+1
		for e in GraphB.edges_iter():
			s = e[0]
			t = e[1]
			link = {
				"id": C_liens,
				"s":s,
				"t":t,
				"w": GraphB[s][t]["weight"]
			}
			Links.append(link)
			# print( "\t" , s ,"->", t )
			# print( NodesD_i2s[ s ] )
			# print( NodesD_i2s[ t ] )
			# print("")
			C_liens += 1

		# print("")
		# print("now links:")
		# print("")
		C_liens = len( Links )+1
		for i in phylojson["links"]:
			s_ = i["s"]
			t_ = i["t"]
			# print( "\tphylojson" , s_ ,"->", t_ )
			# print( phylojson["nodes"][s_] )
			# print( phylojson["nodes"][t_] )
			s = "A_"+str(s_)
			t = "A_"+str(t_)
			# print( NodesD_s2i[ s ] ,"->", NodesD_s2i[ t ] )
			if "hidden" not in i:
				if s in NodesD_s2i and t in NodesD_s2i:
					ID_s = NodesD_s2i[ s ]
					ID_t = NodesD_s2i[ t ]

					link = {
						"id": C_liens,
						"s":ID_s,
						"t":ID_t,
						"type":"line",
						"w": i["w"]
					}
					Links.append( link )
					C_liens += 1






		# Links += phylojson["links"]


		C_liens = len( Links )+1
		# print("")
		# print(" - - - - - -")
		for cID in phylojson["nodes"]:
			ID_s = "A_"+str(cID)
			try:
				if ID_s in NodesD_s2i:
					ID_i = NodesD_s2i[ ID_s ]
					# print( cID ,":",ID_i )

					node_ = phylojson["nodes"][cID]
					node_["id"] = ID_i 
					node_["label"] = cID
					if cID in nodes_md :
						if "supp" in nodes_md[cID]:
							node_["supp"] = nodes_md[cID]["supp"]

					# node_["shape"] = "square" 
					# node_["type"] = "Cluster" 
					# 	"x":float(coord[0]) , 
					# 	"y":float(coord[1]) }
					Nodes.append( node_ )

					if ID_i in nA2B:
						for ngram in nA2B[ID_i]:
							# print( "\t",ngram )

							link = {
								"id": C_liens,
								"s":ID_i,
								"t":ngram,
								"w": 1
							}
							Links.append( link )
							C_liens += 1
			except:
				xxx = 10
				# a year-node

		# # print( "|V_phy|:", len(phylojson["nodes"]))
		# # print( "|E_phy|:", len(phylojson["links"]))
		# # print( "|V|:", len(graphArray["nodes"]))
		# # print( "|E|:", len(graphArray["links"]) )
		graphArray = {
			"nodes": Nodes,
			"links": Links
		}
		return graphArray


	def filter_FIs(self , minfsetsize ):
		return ["hola","mundo"]



	def partial_compute( self , p_ ):

		current_years = set(self.years)

		# print("")
		# print("")
		# print(" In Partial Compute: ")
		# pprint.pprint( p_ )
		# print("")
		# print("")
		t = [ p_["from_"]["value"], p_["to_"]["value"] ]
		add_years = set( range( t[0], t[1]+1 ) ) 
		dt = add_years - current_years
		if len(dt)>0:
			print("need to compute extra:",dt)
			N = self.yearsD
			K = self.minK
			Distribution = {}
			for y in dt:
				period_ = Period( some_sc=self.sc , period=y , numpart=self.partitions )
				n_pubs , n_fis = period_.FPG_unit( self.WL )
				N[ y ] = period_
				Distribution[ y ] = {
					"|FIs|": n_fis,
					"|T|": n_pubs
				}
			years = list(  map( int , (sorted(N.keys())) )  )

			daunion = current_years.union(add_years)
			nyears = sorted(list(daunion))
			newD = {}
			npairs = []
			newcomps = []
			for i in range(len(nyears)):
				try:
					temmmp = [nyears[i],nyears[i+1]]
					npairs.append( temmmp )
					idx = "_".join(list(map(str,temmmp)))
					if idx not in self.pairsD:
						newcomps.append( temmmp )
				except:
					break
					pass
			# self.temp_matching( newcomps)
			# self.pairs, self.pairsD = lineal_comparisons( nyears )
			# pairs, pairsD = lineal_comparisons( years )



			pairs, pairsD = lineal_comparisons( nyears )

			return { "diff_time": { "Distribution": Distribution , "years":nyears , "pairs":pairs , "pairsD":pairsD } }

		# print("")
		# print( "old jacc:", self.minjacc )
		# print( "new jacc:", p_["minjaccard"]  )
		# phylojson = self.filter_jaccard ( p_["minjaccard"] )
		# print("")

		return {}



	# # Slow and obsolete
	def cartesian_product ( self , A , B ):

		N = self.yearsD
		_dists = {}

		# A_FI = N[A].FI.filter(lambda x: len(x.items)>=6 and x.freq>=1).map(lambda x: (x.freq , set(x.items)) )#.zipWithIndex().map( lambda x: ( str(A)+"c"+str(x[1]) , x[0][0] , x[0][1]  )  ) #.map(lambda x: sorted(x.items) )
		# B_FI = N[B].FI.filter(lambda x: len(x.items)>=6 and x.freq>=1).map(lambda x: (x.freq , set(x.items)) )#.zipWithIndex().map( lambda x: ( str(B)+"c"+str(x[1]) , x[0][0] , x[0][1]  )  ) #.map(lambda x: sorted(x.items) )

		A_FI = N[A].FI.map(lambda x: (x[0] , set(x[1])) )
		# for i in A_FI.collect():
		# 	print( i )
		B_FI = N[B].FI.map(lambda x: (x[0] , set(x[1])) )
		pairs = A_FI.cartesian(B_FI)

		do_ = self.utls
		_dists = pairs.map( lambda pair: do_.jaccard( pair[0] , pair[1] )  ).filter( lambda x: x[0]>0 )
		

		return _dists


	def cartesian_product_idx ( self , A , B ):

		N = self.yearsD
		_dists = {}

		# A_FI = N[A].FI.map(lambda x: (x[0] , set(x[1])) )
		# B_FI = N[B].FI.map(lambda x: (x[0] , set(x[1])) )
		# pairs = A_FI.cartesian(B_FI)
		do_ = self.utls
		# _dists = pairs.map( lambda pair: do_.jaccard( pair[0] , pair[1] )  ).filter( lambda x: x[0]>0 )
		
		aa = N[A].K
		bb = N[B].K

		join_terms = aa.join( bb )

		cartesian = join_terms.map( lambda x : list(itertools.product( x[1][0] , x[1][1] )) )
		cartesian = cartesian.flatMap(lambda x: x).groupBy(lambda x: x).map(lambda x : x[0])

		getFIaa = N[A].FI.collectAsMap()
		getFIbb = N[B].FI.collectAsMap()

		pairs = cartesian.map( lambda r :  (r[0],r[1],set(getFIaa[r[0]].items), set(getFIbb[r[1]].items) )  )

		_dists = pairs.map( lambda x: do_.jaccard_idx( x )  )
		_dists = _dists.filter( lambda x: x[0]>0 ).map( lambda x : ( x[0] ,str(A)+"c"+str(x[1]) , str(B)+"c"+str(x[2]) ) )

		# for i in _dists.collect():
		# 	print( i )

		return _dists


# # instatianting and executing
# print("")

# # inst = Period( period=1983 )
# # inst._count( "1983" )
# # inst.test1()
# # inst.test2()
# # inst.FPG_unit()

# lala = Phylo( t=[1983,1985] )
# lala.FPG_chain()
# lala.cartesian_product( 1983 , 1984 )



# print("")
# print("END")
# lala.sc.stop()  # END
