#!/usr/bin/env python
# -*- coding: utf-8 -*-

# python3 A02a_reading-json.py  "exp01/corpora/year.json"  "exp01/dicts/cortext.json"  "exp01/indexed"

import sys
import glob
import json
import pprint
from datetime import datetime
import networkx as nx
import time
import re
import psycopg2



# INPUT     = "raw_json/Pubmed_2011[dp].txt.json"
# OUTPUT    = "folder"
# if len(sys.argv)>1 and sys.argv[1]!=None: INPUT = sys.argv[1]
# if len(sys.argv)>2 and sys.argv[2]!=None: OUTPUT = sys.argv[2]


class LoadShit:

	def __init__(self ):
		# self.INPUT = INPUT
		self.bigD  = {}
		self.stats = {}

	def writeDict( self , orig_file , name , array ):
		filename = orig_file+name
		f = open( filename , "w" )
		f.write( json.dumps( array , indent=1) )
		f.close()
		return filename


	def findout_year( self , filename ):
		YEAR = None
		try: 
			YEAR = re.search(r"\d{4}", filename).group(0)
		except: 
			YEAR = 'None'
			pass

		return YEAR


	def make_index( self , INPUT , suffix ):
		for filename in glob.iglob( INPUT+suffix):
			year = self.findout_year( filename )
			print( year ,"-->", filename )

			C = 0
			f_ = open( filename , "r" )
			for line in f_:
				ttmp = line.replace( "\n" , "")
				ttmp = ttmp.split( " " )
				ttmp = list( map( int , ttmp ) )
				ID = ttmp[0]
				itemset = set(ttmp[1:])
				itemset = sorted( list( itemset ) )
				# print( "\t", ID ,"->", itemset )
				self.bigD[ ID ] = [year,itemset]
				C += 1
			f_.close()


			self.stats[ year ] = C
			break
		print( "FIN" )

	# OBSOLETE
	def intersecting( self  , PMIDList ):
		year_pubs = {
			"data": {},
			"stats": {}
		}

		BigD = self.bigD
		for i in PMIDList:
			print("\t",i ,":",type(i) ," | ", (i in BigD)," | ", (int(i) in BigD))

		for PMID in PMIDList:
			if PMID in BigD:
				y = BigD[ PMID ][0]
				itemset = BigD[ PMID ][1]
				if y not in year_pubs["data"]:
					year_pubs["data"][y] = []
				year_pubs["data"][y].append( [ PMID , itemset ] )
		
		for y in year_pubs["data"]:
			if y not in year_pubs["stats"]:
				year_pubs["stats"][y] = len( year_pubs["data"][y] )


		return year_pubs


	def chunks(self, l, n):
		"""Yield successive n-sized chunks from l."""
		for i in range(0, len(l), n):
			yield l[i:i + n]

	def intersecting_psql( self  , PMIDList=[] , step=5000 , t=[] ):

		DB = "pubmed"
		TABLE = "publication"
		COLS = "*"

		year_pubs = {
			"data": {},
			"stats": {},
			"hits": 0
		}

		import psycopg2
		conn = psycopg2.connect("dbname="+DB+" user=pksm3")
		c = conn.cursor()

		chunks = list( self.chunks( PMIDList , step) )

		for chunk in chunks:

			sql = "SELECT "+COLS+" from "+TABLE+" WHERE "
			if len(t)==2:
				sql += "(year>="+str(t[0])+" AND year<="+str(t[1])+") AND "

			elems = " or id=".join( chunk )
			sql += "( id="+elems+")"
			c.execute(sql)
			results = c.fetchall()
			year_pubs["hits"] += len(results)
			print(len(chunk),"->",len(results))
			# print( "input",":",len(chunk)," -> ",len(results) )
			for i in results:
				PMID = i[0]
				y = i[1]
				itemset = i[2]
				if y not in year_pubs["data"]:
					year_pubs["data"][y] = []
				year_pubs["data"][y].append( [ PMID , itemset ] )
		
		for y in year_pubs["data"]:
			if y not in year_pubs["stats"]:
				year_pubs["stats"][y] = len( year_pubs["data"][y] )


		return year_pubs


	def get_ngrams( self  , elemsID=[] , step=5000):

		DB = "meshfiltrd"
		TABLE = "june2016"
		COLS = "*"


		import psycopg2
		conn = psycopg2.connect("dbname="+DB+" user=pksm3")
		c = conn.cursor()

		chunks = list( self.chunks( elemsID , step) )


		results = {}
		for chunk in chunks:

			sql = "SELECT "+COLS+" from "+TABLE+" WHERE "

			elems = " or id=".join( chunk )
			sql += "( id="+elems+")"
			c.execute(sql)
			matches_ = c.fetchall()
			for i in matches_:
				results[i[0]] = i[1]
		conn.close()

		return results

# WL = []
# f_ = open( "/datasets/PubMed2014/gut-brain.txt" , "r")
# for line in f_:
# 	ID = line.replace("\n","")
# 	WL.append( ID )
# f_.close()

# inst_ = LoadShit()
# ress = inst_.intersecting_psql( WL )
# pprint.pprint( ress["stats"] )