#!/usr/bin/env python
# -*- coding: utf-8 -*-


import sys
import glob
import json
import pprint
from datetime import datetime
import time
import re



# INPUT     = "raw_json/Pubmed_2011[dp].txt.json"
# OUTPUT    = "folder"
# if len(sys.argv)>1 and sys.argv[1]!=None: INPUT = sys.argv[1]
# if len(sys.argv)>2 and sys.argv[2]!=None: OUTPUT = sys.argv[2]


class LoadShit:

	def __init__(self ):
		# self.INPUT = INPUT
		self.bigD  = []
		self.stats = {}


	def findout_year( self , filename ):
		YEAR = None
		try: 
			YEAR = re.search(r"\d{4}", filename).group(0)
		except: 
			YEAR = 'None'
			pass

		return YEAR


	def make_index( self , INPUT , suffix ):

		DD = {}

		for filename in glob.iglob( INPUT+suffix ):
		
			print(filename)
			year = self.findout_year( filename )
			print( year ,"-->", filename )

			C = 0
			f_ = open( filename , "r" )
			for line in f_:
				ttmp = line.replace( "\n" , "")
				ttmp = ttmp.split( " " )
				ID = int(ttmp[0])
				if ID not in DD:
					DD[ID] = True
					ttmp = list( map( int , ttmp ) )
					itemset = set(ttmp[1:])
					itemset = sorted( list( itemset ) )
					# print( "\t", ID ,"->", itemset )
					self.bigD.append( (ID,year,itemset,) )
					C += 1
			f_.close()


			self.stats[ year ] = C
			# break
		# print( "FIN" )

	# def intersecting( self  , PMIDList ):
	# 	year_pubs = {
	# 		"data": {},
	# 		"stats": {}
	# 	}

	# 	BigD = self.bigD
	# 	for i in PMIDList:
	# 		print("\t",i ,":",type(i) ," | ", (i in BigD)," | ", (int(i) in BigD))

	# 	for PMID in PMIDList:
	# 		if PMID in BigD:
	# 			y = BigD[ PMID ][0]
	# 			itemset = BigD[ PMID ][1]
	# 			if y not in year_pubs["data"]:
	# 				year_pubs["data"][y] = []
	# 			year_pubs["data"][y].append( [ PMID , itemset ] )
		
	# 	for y in year_pubs["data"]:
	# 		if y not in year_pubs["stats"]:
	# 			year_pubs["stats"][y] = len( year_pubs["data"][y] )


	# 	return year_pubs

# import LoadShit
I = LoadShit()
I.make_index( "Full_pearson-filter" , '/*' )
# # pprint.pprint( I.stats )

import psycopg2
conn = psycopg2.connect("dbname=pubmed user=pksm3")
c = conn.cursor()

sql_commands = [
	"DROP TABLE IF EXISTS publication;",
	"CREATE TABLE publication( id INTEGER PRIMARY KEY , year INTEGER , itemset INTEGER ARRAY )",
]

for command in sql_commands:
	c.execute(  command )
	conn.commit()


DATA = I.bigD
print("")
print("inserting...",len(DATA))
from SQL import SQL
execc = SQL()
execc.InsertInto_modular( connection=conn , cursor=c , tablename="publication" , data= DATA )



print("creating indexes...")
sql_indexes = [
	"CREATE INDEX year_idx ON publication (year);"
]
for command in sql_indexes:
	c.execute(  command )
	conn.commit()


conn.close()









# # # CREATE INDEX # #
# import psycopg2
# conn = psycopg2.connect("dbname=pubmed user=pksm3")
# c = conn.cursor()
# print("creating indexes...")
# sql_indexes = [
# 	"CREATE INDEX year_idx ON publication (year);"
# ]
# for command in sql_indexes:
# 	c.execute(  command )
# 	conn.commit()
# conn.close()