
#!/usr/bin/env python
# -*- coding: utf-8 -*-


import json
import sys
import os
import re
import networkx as nx
from ast import literal_eval

import pygraphviz as pgv
import pprint
import time
# from itertools import combinations


#
# python3 01_workflow-output_2json.py testMESH/edgesk9 testMESH_formatted
#
class PhyloMaker:
	def __init__(self , input_ , output_ , jcc_):
		self.INPUT = input_
		self.OUTPUT = output_
		self.JCC = 0.0

	def writeDict(self, orig_file , name , array ):
		filename = orig_file+name
		f = open( filename , "w" )
		f.write( json.dumps( array , indent=1) )
		f.close()
		return filename

	def writeG( self , filename , G , Labels ):

		# from networkx import isolates
		# G.remove_nodes_from(isolates(G))

		B = {}
		B["nodes"] =[]
		for n in G.nodes_iter():
			COOCC = G.degree( n )
			node = {
				"attributes":{
					"coocc": COOCC
				},
				"id": n,
				"label": Labels[n],
				"type": "Doc",
				"size": 3 #GraphA.degree(n)
			}
			B["nodes"].append( node )



		B["links"] = []
		for e in G.edges_iter():
			s = e[0]
			t = e[1]
			weight = G[s][t]["weight"]
			info = {  "s": s , "t": t , "w": weight  }
			B["links"].append(info)


		outfile =  filename
		f = open( outfile , "w" )
		f.write( json.dumps( B, indent=1 ) )
		f.close()


	# <from> networkx.Graph  <to>  [ nodes-dict + edges-list ]
	def convert__( self , G , Labels ):

		# from networkx import isolates
		# G.remove_nodes_from(isolates(G))

		B = {}
		B["nodes"] ={}
		for n in G.nodes_iter():
			COOCC = G.degree( n )
			# print("jjj",n,COOCC,Labels[n])
			node = {
				"attributes":{
					"coocc": COOCC
				},
				"id": n,
				"label": Labels[n],
				"type": "Doc",
				"size": 3 #GraphA.degree(n)
			}
			# print(node)
			B["nodes"][n] = node



		B["links"] = []
		for e in G.edges_iter():
			s = e[0]
			t = e[1]
			weight = G[s][t]["weight"]
			info = {  "s": s , "t": t , "w": weight  }
			B["links"].append(info)

		# print("|V--|",len(B["nodes"]))
		# print("|E--|",len(B["links"]))
		return B



	def openJSON( self , filename ):
		# print("reading...")
		data = []
		f = open( filename , "r" )
		# data = json.load( f )
		for line in f:
			lien = line.replace("\n","").split(" ")
			# print(lien)
			data.append( lien )
		f.close()
		return data


	def export_phylo( self , liens , T , jacc_min):


		start = time.time()

		inputfile = "hola"

		Year_CL = {}
		self.AG = nx.DiGraph()
		AG = self.AG

		NodeIDs = {}
		for e in liens:
			s = e[1]
			t = e[2]
			w = e[0]
			try:
				if w >= jacc_min:
					# print(e)
					ys = int(s.split("c")[0])
					yt = int(t.split("c")[0])
					# print( "\t",VV[s]["label"],"-",VV[t]["label"] )
					if ys>=T[0] and ys<=T[1] and yt>=T[0] and yt<=T[1]:
						NodeIDs[s] = True
						NodeIDs[t] = True

						if ys not in Year_CL: 
							Year_CL[ys] = {}
						Year_CL[ys][s] = True

						if yt not in Year_CL: 
							Year_CL[yt] = {}
						Year_CL[yt][t] = True
				# print("")

			except:
				pass
		print("< |FIs| / time >")
		# pprint.pprint( list(NodeIDs.keys()) )
		for i in Year_CL:
			print(i,":",len(Year_CL[i]))
		print("< / |FIs| / time >")
		 # - - - - - [ Adding yearly-graph ] - - - - - #
		years = Year_CL.keys()
		for y in years:
			AG.add_node(str(y), label=y , fake=True ,shape="plaintext")

		for i in sorted(years):
			try:
				AG.add_edge(str(i),str(i+1),fake=True,weight=1)
			except:
				pass
		 # - - - - - [ / Adding yearly-graph ] - - - - - #


		for y in Year_CL:
			for ID in Year_CL[y]:
				if ID in NodeIDs:
					label = Year_CL[y][ID]
					AG.add_node(ID, shape="square" , y=y , label=label, fontsize=7)


		for e in liens:
			s = e[1]
			t = e[2]
			w = e[0]
			try:
				if w >= jacc_min:
					ys = int(s.split("c")[0])
					yt = int(t.split("c")[0])
					if ys>=T[0] and ys<=T[1] and yt>=T[0] and yt<=T[1]:

						if ys > yt: 
							AG.add_edge(t,s,weight=w)
							# print( ys,yt )
							# # print G["nodes"][t]["label"] ,"->", G["nodes"][s]["label"]
						else: 
							if ys == yt:
								# print G["nodes"][s]["label"] ,"->", G["nodes"][t]["label"]
								xxx = 10
							else:
								AG.add_edge(s,t,weight=w)
			except:
				pass

		# # pprint.pprint(Year_CL)
		# for i in Year_CL:
		# 	print(i,":",len(Year_CL[i]))

		# print(" - - - -- - - - ")
		# # print "|V|" , len(AG) 
		# # print "|E|" , AG.number_of_edges()
		# # print("")
		# AG.remove_nodes_from(nx.isolates(AG))


		# # A = nx.drawing.nx_agraph.to_agraph(AG)
		# # for y in sorted(list(Year_CL.keys())):
		# # 	clusters = list(Year_CL[y].keys())
		# # 	A.add_subgraph( clusters , rank='same')
		# # A.layout(prog='dot')
		# # A.draw(self.PATHFILE+'_A.'+self.EXT, prog='dot')


		# redundant_ = nx.DiGraph()
		Parents = {  }
		for n in AG.nodes_iter():
			node = AG.node[n]
			if "fake" not in node:
				succesors = AG.neighbors( n )
				if len( succesors )>0:
					Parents[n] = sorted( succesors )
					# print( n )
					# for j in succesors:
					# 	print( "\t",j )
					# print("- - - - ")
					# print("")
		# 	if "fake" not in node:
		# 		parents = AG.predecessors( n )
		# 		if len(parents)>=2:
		# 			family = {}
		# 			for p in parents:
		# 				gpy = AG.node[p]["y"]
		# 				if gpy not in family:
		# 					family[ gpy ] = []
		# 				family[ AG.node[p]["y"] ].append( p )
		# 			family[node["y"]] = [ n ]
		# 			family_k = sorted(list(family.keys()))
		# 			family_D = {}
		# 			for i in range(len(family_k)): 
		# 				family_D[ family_k[i] ] = i


		# 			if len(family_k)>=3:
		# 				for p in parents:
		# 					# ancestor = AG.node[p]
		# 					# ego = node
		# 					if ( family_D[node["y"]] - family_D[AG.node[p]["y"]] ) >=2:
		# 						infoA = { "y":AG.node[p]["y"] , "id":p , "label":AG.node[p]["label"] }
		# 						infoB = { "y":node["y"] , "id":n , "label":node["label"] }
		# 						nA_has_descendance = self.verify_descendance( infoA , infoB , family )
		# 						if nA_has_descendance: # then remove the edge
		# 							redundant_.add_edge( infoA["id"] , infoB["id"] )

		# AG.remove_edges_from( redundant_.edges() )
		# # AG.remove_nodes_from(nx.isolates(AG))
		


		# # Remove not-relevant intertemporal-clusters
		# clusters_bof = {}
		# for n in AG.nodes_iter():
		# 	if "fake" not in AG.node[n]:
		# 		if AG.out_degree(n)==0 and AG.in_degree(n)<=1:
		# 			parent = AG.predecessors( n )[0]
		# 			if AG.out_degree(parent)<=1 and AG.in_degree(parent)==0:
		# 				# print AG.node[parent]["label"] ,",", AG.node[n]["label"]
		# 				if ( AG.node[n]["y"] - AG.node[parent]["y"]) <=999:
		# 					clusters_bof[parent] = True
		# 					clusters_bof[n] = True
		# AG.remove_nodes_from( list(clusters_bof.keys()) )
		# AG.remove_nodes_from( list(map( str , Year_CL.keys())) )


		# # print("")
		print("using graphviz, dot layout... INI")
		B = nx.drawing.nx_agraph.to_agraph(AG)
		for y in sorted(list(Year_CL.keys())):
			clusters = list(Year_CL[y].keys())
			clusters.insert(0, str(y) )
			# print  y,":", len(clusters)
			# print "\t",clusters
			# print ""
			B.add_subgraph( clusters , rank='same')


		B.layout(prog='dot')
		# A.draw(self.PATHFILE+'_B.'+self.EXT, prog='dot')


		# NodesDict = []
		# EdgesDict = []

		# Phy_C = 1
		# Phy_D = {}
		# for i in B:
		# 	# if "fake" not in AG.node[i]:
		# 	n=B.get_node(i)
		# 	coord = n.attr["pos"].split(",")
		# 	# # print " label =", n.attr["label"]# , " : (" , coord[0] , "," , coord[1] , ")"
		# 	# if int(n.attr["y"])==years[-1]:
		# 	#	 print n.attr
		# 	infodict = { "id":Phy_C , "label":n , "shape":"square" , "x":float(coord[0]) , "y":float(coord[1]) }
		# 	NodesDict.append(infodict)
		# 	Phy_D[n] = Phy_C
		# 	Phy_C += 1


		# for e in B.edges_iter():
		# 	s = e[0]
		# 	t = e[1]
		# 	# if "fake" not in AG[s][t]:
		# 	# print(e)
		# 	infodict = {"s":Phy_D[s] , "t":Phy_D[t] , "w":AG[s][t]["weight"] , "type":"line" }
		# 	EdgesDict.append(infodict)

		# Graph = {  
		# 	"graph":[],
		# 	"directed":False,
		# 	"multigraph":False,
		# 	"nodes": NodesDict,
		# 	"links": EdgesDict
		# }

		# end = time.time()
		# print(float("{0:.2f}".format(end - start)),"[s] : dot layout FIN")


		NodesDict = {}
		EdgesDict = []

		Phy_C = 1
		Phy_D = {}
		for i in B:
			# if "fake" not in AG.node[i]:
			n=B.get_node(i)
			coord = n.attr["pos"].split(",")
			# # print " label =", n.attr["label"]# , " : (" , coord[0] , "," , coord[1] , ")"
			# if int(n.attr["y"])==years[-1]:
			#	 print n.attr
			infodict = { "id":Phy_C , "label":n , "shape":"square" , "type":"Cluster" , "x":float(coord[0]) , "y":float(coord[1]) }
			NodesDict[n] = infodict
			Phy_D[n] = Phy_C
			Phy_C += 1


		for e in B.edges_iter():
			s = e[0]
			t = e[1]
			infodict = {"s":s , "t":t , "w":AG[s][t]["weight"] , "type":"line" }
			if "fake" in AG[s][t]:
				infodict["hidden"] = True
			EdgesDict.append(infodict)

		Graph = {  
			"graph":[],
			"directed":False,
			"multigraph":False,
			"nodes": NodesDict,
			"links": EdgesDict
		}

		end = time.time()
		print(float("{0:.2f}".format(end - start)),"[s] : dot layout FIN")

		return Graph, Parents
