# pip install  simplejson  git+https://github.com/miguelgrinberg/Flask-Runner.git
# pip install biopython
#   more: https://flask-runner.readthedocs.io/en/latest/

# sudo su pksm3
# export SPARK_HOME="/opt/spark2"
# export PATH=$SPARK_HOME/bin:$PATH
# source env/bin/activate
# python phylum_srv.py -t 0.0.0.0 -p 8080

from flask import Flask, render_template, request , flash , jsonify , url_for
from flask.ext.runner import Runner #*#
import simplejson as json

from flask_wtf import Form
from wtforms import StringField, TextField, IntegerField, DecimalField, validators
from wtforms.validators import DataRequired
from flask_wtf.csrf import CsrfProtect
csrf = CsrfProtect()

from PhyloSpark import Phylo
import datetime
import pprint
import time

app = Flask(__name__ , static_url_path='/static' )
app.secret_key = 's3cr3t'
csrf.init_app(app)
runner = Runner(app) #*#
from bigindex import LoadShit
import urllib


import findspark
findspark.init()
from pyspark import SparkContext
from pyspark import SparkConf

cfg = SparkConf().set('spark.driver.memory', "40g").set('spark.driver.cores', 20 ).setAppName("simple_app")
# .setMaster(cluster_url)
ncores = 20
sc__ = SparkContext(conf=cfg)

I = {}

class BabelForm(Form):
	instname = StringField('instance name', validators=[DataRequired()])
	frequency = IntegerField('Min. term frequency', [validators.NumberRange(min=1, max=10)])
	from_ = IntegerField('From', [validators.NumberRange(min=1983, max=2014)])
	to_ = IntegerField('To', [validators.NumberRange(min=1983, max=2014)])
	minsupp = DecimalField('Min. support', [validators.NumberRange(min=0.00, max=0.99)])
	minfsetsize = IntegerField('Min. FI size', [validators.NumberRange(min=1, max=10)])
	minjaccard = DecimalField('Min. Jaccard', [validators.NumberRange(min=0.00, max=0.99)])
	ram = StringField('RAM', validators=[DataRequired()])
	cores = StringField('#cores', validators=[DataRequired()])
	# cooccs = IntegerField('Min. term voisinage', [validators.NumberRange(min=1, max=10)])

def flash_errors(form):
	for field, errors in form.errors.items():
		for error in errors:
			flash(u"Error in the %s - %s" % (
				getattr(form, field).label.text,
				error
			))


@csrf.exempt
@app.route("/ngrams", methods=("GET", "POST",))
def ngrams():
	K = []
	if request.method == "POST":
		p_ = {}
		# print( "did a POST" )
		for i in request.form:
			ID = i.replace("[]","")
			p_[ID] = request.form.getlist(i)

		# print( p_ )

		elems = p_["elems"]
		from bigindex import LoadShit
		ii = LoadShit()
		K = ii.get_ngrams( elemsID=elems )

	return jsonify( K )




@app.route("/close", methods=("GET",))
def close_contexts():
	for i in I:
		I[i].sc.stop()
		return json.dumps( ["connections","closed"] )

	for i in I:
		del I[i]


# p_["scontext"] (value="blabla")
# p_["elemfrequency"] (value="1")
# p_["from_"] (value="1983")
# p_["to_"] (value="1984")
# p_["minfpgsupp"] (value="0.0001")
# p_["minfsetsize"] (value="4")
# p_["minsetdistance"] (value="0.2")
# p_["mram"] (value="0.2")
# p_["ncores"] (value="0.2")
@csrf.exempt
@app.route("/test" , methods=("GET", "POST",))
def test_post():
	pprint.pprint( request )
	query = "void"
	GG = { "nodes": [] , "links": [] }
	stats = False
	records = { "Count": 0 }
	if request.method == "POST":
		p_ = {}
		print( "did a POST" )
		for i in request.form:
			print( i , ":", request.form[i] )
			p_[i] = request.form[i]


		t_i = time.time() ##
		# print( "downloading..." ) ##

		query = urllib.parse.unquote(p_["query"])
		query_size = p_["c"]
		from Bio import Entrez
		Entrez.email = "Your.Name.Here@example.org"
		handle = Entrez.esearch(db="pubmed", retmax=query_size, term=query)
		records = Entrez.read(handle)
		handle.close()

		print("") ##
		t_f = time.time() ##
		print ("downloading:", float("{0:.3f}".format((t_f - t_i))) ) ##
		print("") ##
		print("") ##


		# t_i = time.time() ##
		# print( "intersecting..." ) ##


		# # from bigindex import LoadShit
		# # ii = LoadShit()
		# # P = ii.intersecting_psql( records["IdList"] , t=[ p_["from_"] , p_["to_"] ]) # complete
		# # # P = ii.intersecting_psql( records["IdList"] , t=[ 2008 , 2009 ])
		# # print( "" )
		# # pprint.pprint( P["stats"] )
		# # print( "hits:",P["hits"] )
		# # if P["hits"]==0:
		# # 	return json.dumps( {"hits":0} )

		# t_f = time.time() ##
		# print ("intersecting:", float("{0:.3f}".format((t_f - t_i))) ,"[s]") ##
		# print("") ##

		sID = query #p_["scontext"]


		if sID not in I:

			# if len( I.keys() )==0:
			# 	memm=p_["mram"]+"g" , 
			# 	ncores=p_["ncores"]

			# 	theconf = SparkConf().set('spark.driver.memory', memm).set('spark.driver.cores', ncores)
			# 	# .setAppName("broadcastfail")
			# 	# .setMaster(cluster_url)
			# 	sc__ = SparkContext(conf=theconf)


			# 	# SparkContext.setSystemProperty('spark.executor.memory', memm)
			# 	# SparkContext.setSystemProperty('spark.driver.memory', memm)
			# 	# SparkContext.setSystemProperty('spark.executor.cores', ncores)
			# 	# SparkContext.setSystemProperty('spark.driver.cores', ncores)
			# 	# sc__ = SparkContext("local["+ncores+"]","simple app")

			print("")
			print("")
			pprint.pprint( sc__._conf.getAll() )
			print("")
			print("")
			print( " - - -- - -" )
			print( " - - -- - -" )
			pprint.pprint( p_ )
			print( " - - -- - -" )
			print( " - - -- - -" )


			periods_ = range( int(p_["from_"]) , int(p_["to_"])+1 )
			# periods_ = range( 2008 , 2011 )
			minjaccard = float(p_["minsetdistance"])
			I[ sID ] = Phylo( t=periods_ , minJ=float(p_["minsetdistance"]) , spark_context=sc__ , ncores=ncores )


			for k in p_:
				if "scontext"!=k:
					try:
						# print("\t\t",k)
						the_type = I[ sID ].p[k]["type"]
						I[ sID ].p[k]["value"] = the_type(p_[k])
					except:
						# print("\t\t\t",k,"\t","error!!!")
						pass
			print("\nYour \"",sID,"\" instance has been CREATED.")
			pprint.pprint( I[ sID ].p )
			print( "" )
			print( "" )


			# executes a fp-growth per year
			stats , years , pairs , pairsD = I[ sID ].FPG_chain( t=periods_ , WL=records["IdList"] )
			I[ sID ].years , I[ sID ].pairs , I[ sID ].pairsD = years , pairs , pairsD
			
			# # pairs of years to be multiplied
			I[ sID ].temp_matching(  thepairs = pairs )
			filters_ = {
				"jacc_min": I[ sID ].p["minsetdistance"]["value"],
				"minfsetsize": I[ sID ].p["minfsetsize"]["value"],
				"minfsetsupp": I[ sID ].p["minfsetsupp"]["value"],
			}
			GG = I[ sID ].filter_jaccard ( filter_s=filters_ )


			if len( GG["links"] )>0:
				Ya = p_["from_"]
				Yb = p_["to_"]
				GG_v = str( len( GG["nodes"] ) )
				GG_e = str( len( GG["links"] ) )
				query_file = query.replace(" ","_")+"__"+Ya+"-"+Yb+"__"+GG_v+"x"+GG_e
				f = open( "static/Phylo/data/"+query_file+".json","w")
				f.write( json.dumps( GG,indent=1 ) )
				f.close()

		else: 
			print("\nYour \"",sID,"\" instance has been MODIFIED.")
			print( "\t" , "before:" )
			pprint.pprint( I[ sID ].p )
			print( "" )
			params_ = {}
			# # Updating   I[ sID ].p   parameters with new ones # #
			for k in p_:
				if "scontext"!=k:
					try:
						# print("\t\t",k)
						the_type = I[ sID ].p[k]["type"]
						I[ sID ].p[k]["value"] = the_type(p_[k])
					except:
						# print("\t\t\t",k,"\t","error!!!")
						pass
			print( "" )
			print( "\t" , "after:" )
			pprint.pprint( I[ sID ].p )
			print( "" )
			
			diff_ress = I[ sID ].partial_compute( I[ sID ].p )
			if "diff_time" in diff_ress:
				# I[ sID ].stats = diff_ress["stats"]
				I[ sID ].years = diff_ress["diff_time"]["years"]
				I[ sID ].pairs = diff_ress["diff_time"]["pairs"]
				I[ sID ].pairsD = diff_ress["diff_time"]["pairsD"]

				I[ sID ].temp_matching(  thepairs = diff_ress["diff_time"]["pairs"] )
				filters_ = {
					"jacc_min": I[ sID ].p["minsetdistance"]["value"],
					"minfsetsize": I[ sID ].p["minfsetsize"]["value"],
					"minfsetsupp": I[ sID ].p["minfsetsupp"]["value"],
				}
				GG = I[ sID ].filter_jaccard ( filter_s=filters_ )
			else:
				pairs = I[ sID ].pairs
				I[ sID ].temp_matching(  thepairs = pairs )
				filters_ = {
					"jacc_min": I[ sID ].p["minsetdistance"]["value"],
					"minfsetsize": I[ sID ].p["minfsetsize"]["value"],
					"minfsetsupp": I[ sID ].p["minfsetsupp"]["value"],
				}
				GG = I[ sID ].filter_jaccard ( filter_s=filters_ )



			if len( GG["links"] )>0:
				Ya = str(I[ sID ].p["from_"]["value"])
				Yb = str(I[ sID ].p["to_"]["value"])
				GG_v = str( len( GG["nodes"] ) )
				GG_e = str( len( GG["links"] ) )
				query_file = query.replace(" ","_")+"__"+Ya+"-"+Yb+"__"+GG_v+"x"+GG_e
				f = open( "static/Phylo/data/"+query_file+".json","w")
				f.write( json.dumps( GG,indent=1 ) )
				f.close()





		rr = {
			"query": query,
			"expected": records["Count"],
			# "real": len(records["IdList"]),
			"phylojson": GG,
			"stats": stats
		}
		return json.dumps( rr )
		# return json.dumps( ["post","worked","mofos"] )

	return json.dumps( ["regular","get"] )
	# return jsonify( data=["normal","return"] )




@app.route('/api/context/<contextID>', methods=("GET",))
def get_context(contextID=None):
	results = ["null"]
	if contextID in I:
		to_show = I[contextID].get_atts( scn=contextID )
		return jsonify( to_show )
	return jsonify( results )


@app.route( "/pubmed_search" , methods=("GET",) )
def pubmed_search():
	return render_template("pubmed_autocomplete.html")



@csrf.exempt
@app.route("/search" , methods=("GET","POST",) )
def search_pm():


	if request.method == "POST":
		p_ = {}
		# print( "did a POST" )
		for i in request.form:
			contenu=urllib.parse.unquote(request.form[i])
			print( i , ":", contenu )
			p_[i] = contenu
			

		query = p_["query"]
		query_size = p_["c"]
		from Bio import Entrez
		Entrez.email = "Your.Name.Here@example.org"
		handle = Entrez.esearch(db="pubmed", retmax=query_size, term=query)
		records = Entrez.read(handle)
		handle.close()
		
		from bigindex import LoadShit
		ii = LoadShit()
		T = ii.intersecting_psql( records["IdList"] )
		
		rr = {
			"query": query,
			"expected": records["Count"],
			"real": len(records["IdList"]),
			"PMIDList": records["IdList"],
			"all": results
		}
		return json.dumps( rr )

	return json.dumps( ["ahhhhh"] )


# @csrf.exempt
# @app.route("/pmid/<pmids>" , methods=["GET"])
# def search_pmids(pmids):
	
# 	PMIDList = pmids.split(",")
# 	# PMIDList = list( map( int , PMIDList ) )
# 	results = I.intersecting_psql( PMIDList )


# 	return json.dumps( results["stats"] )
# 	# return jsonify( data=["normal","return"] )





runner.run()
