import sys
import simplejson as json
import pprint
import time


TEST_CASE = -1
if len(sys.argv)>1 and sys.argv[1]!=None: TEST_CASE = sys.argv[1]

THREADS = 16



def lala():
	from PhyloSpark import Phylo
	lala = Phylo( t=[1983,1984] )
	lala.FPG_chain()
	results = lala.cartesian_product( 1983 , 1984 )
	# results = lala.cartesian_product( 1984 , 1985 )

# define the function blocks
def test_cartesianproduct():
	from PhyloSpark import Phylo
	lala = Phylo( t=[1983,1984] )
	lala.FPG_chain()
	results = lala.cartesian_product( 1983 , 1984 ).collect()
	for i in results:
		print(i)
	# results.saveAsTextFile( str(1983)+"-"+str(1984) )
	#pprint.pprint( json.dumps(results) )
	#print( "1983  x  1984 = ",len(results))

def reading_jaccs():
	from output_2json import PhyloMaker
	thepath = "OUTPUTS/"+"2016-10-04T13:35:01.926967"
	lll = PhyloMaker(thepath , thepath , 0.0)
	Graph = lll.iter_folder(thepath)

	print("1... |V|",len(Graph["nodes"]))
	print("1... |E|",len(Graph["links"]))

	timerange = [ 1982 , 2007 ]
	Graph_ = lll.processJSON_test( Graph , timerange)

	print("2... |V|",len(Graph_["nodes"]))
	print("2... |E|",len(Graph_["links"]))
	import json
	f = open( "OUTPUTS/"+"phylo_twjs.json","w")
	f.write(json.dumps(Graph_,indent=1))
	f.close()

def prime():
	print ("n is a prime number\n")


def interRDD_join():
	P_path = "/datasets/PubMed2014/Full_pearson-filter/2010.json.txt"
	WL_path = "/datasets/PubMed2014/chikungunya.txt"

	from PhyloSpark import Phylo
	the_ = Phylo( t=[1983,1984] )

	t_i = time.time() ##
	print( "joining..." ) ##

	P = the_.sc.textFile( P_path ).map( lambda line: [int(x) for x in line.strip().split(' ')] ).filter( lambda x: len(x)>=3 )
	P = P.map( lambda x : (x[0] , x[1:],) )

	WL = the_.sc.textFile( WL_path ).map( lambda line: (int(line.strip()) , 1) )


	# IDs = T.map(lambda x : ( x[0],1,) )

	# pprint.pprint( WL.collect() )

	ress = P.join( WL ).map(lambda x: (x[0],x[1][0])).collect()
	print("") ##
	t_f = time.time() ##
	print ("joining:", float("{0:.3f}".format((t_f - t_i))) ,"[s]") ##
	print("") ##
	print(ress)


def interRDD_intersection():
	P = "/datasets/PubMed2014/Full_pearson-filter/2010.json.txt"
	WL = "/datasets/PubMed2014/chikungunya.txt"

	from PhyloSpark import Phylo
	the_ = Phylo( t=[1983,1984] )

	T = the_.sc.textFile( P ).map( lambda line: [int(x) for x in line.strip().split(' ') if len(x)>=3 ] )

	SL = the_.sc.textFile( WL ).map( lambda line: int(line.strip()) )

	IDs = T.map(lambda x : x[0])

	ress = SL.intersection( IDs ).collect()
	print(ress)


def processLine( line ):
	array = list(map(int,line.strip().split(' ')))
	return (array[0],array[1:]);


def getWL ( sc_ , query ):
	return sc_.textFile( query ).map( lambda line: (int(line.strip()),1) )


def interDataSet( sc_ , period , WL ):
	P_path = "/datasets/PubMed2014/Full_pearson-filter/"+period+".json.txt"

	t_i = time.time() ##
	print( "joining..." ) ##

	P = sc_.textFile( P_path ).map( lambda line: [int(x) for x in line.strip().split(' ')] ).filter( lambda x: len(x)>=3 )
	P = P.map( lambda x : (x[0] , x[1:],) )

	# IDs = T.map(lambda x : ( x[0],1,) )

	# pprint.pprint( WL.collect() )

	Psub = P.join( WL ).map(lambda x: (x[0],x[1][0]))#.collect()
	# # print( period,", found:",len(intersecciones.collect()) )
	# # # for i in intersecciones:
	# # # 	print(i)
	# ress = intersecciones.map(lambda x : str(x[0])+" "+" ".join(list(map(str,x[1]))) )
	# # # for i in ress.collect():
	# # # 	print(i)
	# # ress.coalesce(1).saveAsTextFile(period)
	return Psub


def test_workflow():

	import time
	print("hello")

	minsupp = 0.0001
	numpart = 100

	minfsetsize = 4



	import findspark
	findspark.init()
	from pyspark.mllib.fpm import FPGrowth
	from pyspark import SparkContext
	from pyspark import SparkConf
	cfg = SparkConf().set('spark.driver.memory', "40g").set('spark.driver.cores', 20 ).setAppName("simple_app")
	ncores = 20
	sc__ = SparkContext(conf=cfg)
	from PhyloSpark import Phylo

	periods_ = range(2003,2005+1)
	the_ = Phylo( t=periods_ , minJ=0.0 , spark_context=sc__ , ncores=ncores )

	# WL = getWL( the_.sc , "/datasets/PubMed2014/chikungunya.txt" )
	WL_path = "/datasets/PubMed2014/chikungunya.txt"
	# WL_path = "/datasets/PubMed2014/gut_AND_brain.txt"
	WL = sc__.textFile( WL_path ).map( lambda line: (int(line.strip()) , 1) )


	# WL = getWL( the_.sc , "/datasets/PubMed2014/cell-aging.txt" )
	# WL = getWL( the_.sc , "/datasets/PubMed2014/rheumatoid-arthritis.txt" )


	for i in range(2003,2005+1):
		start = time.time()
		period = str(i)
		# print(period)
		T = interDataSet( sc__ , period , WL ).map(lambda x: x[1] )
		print("\t",period,"->",len(T.collect()))
		# print( "\t", T.take(1))
		model = FPGrowth.train(T, minSupport=minsupp, numPartitions=numpart)
		FI_all_c = model.freqItemsets().count()
		print("\t\t |FI|", FI_all_c)


		t_i = time.time() ##

		FI = model.freqItemsets().filter(lambda x: len(x.items)>=minfsetsize and x.freq>=2)
		FI = FI.sortBy(lambda x: x.freq , ascending=False).zipWithIndex().map( lambda x : (x[1],x[0]) ).persist()
		
		FI_c = FI.count()
		t_f = time.time() ##
		FI_t = "{0:.3f}".format((t_f - t_i)) +"[s]" ##
		print("\t\t |FI_| ", FI_c , "\t",FI_t )
		print("")


		# end = time.time()
		# print("\t\t",end - start)
		print("")

def test_newstruct():
	print("     test_newstruct     ")
	from PhyloSpark import Phylo
	import itertools

	from InterUnion import Utils
	utls = Utils()

	# periods_ = [ 2012 , 2014 ]
	periods_ = [ 2010 , 2011 ]
	minjaccard = 0.0
	ddo = Phylo( t=periods_ , minJ=minjaccard , memm="10g" , ncores="10" )
	ddo.FPG_chain() 


	# # # = = = (  x[0]  , x[1] ) = = = # # # 
	# # # = = = ( elemID<PRI> , clusters<resultiterable> ) = = = # # # 
	aa = ddo.yearsD[periods_[0]].K
	bb = ddo.yearsD[periods_[1]].K

	# len_FIaa = ddo.yearsD[periods_[0]].FI_c
	# len_FIbb = ddo.yearsD[periods_[1]].FI_c



	# # # # = = ( x[0] , x[1]<FreqItemset> ) = = = # # # 
	FIaa = ddo.yearsD[periods_[0]].FI
	FIbb = ddo.yearsD[periods_[1]].FI


	# # print(periods_[0],":", ddo.yearsD[ periods_[0] ].K)
	# # for i in aa.collect():
	# # 	print( i[0],list(i[1]) )
	# # print("")
	# # print(periods_[1],":", ddo.yearsD[ periods_[1] ].K)
	# # for i in bb.collect():
	# # 	print( i[0],list(i[1]) )
	# # print("")
	# # intersecciones = aa.join( bb )
	# # ress = intersecciones.collect()
	# # print("")
	# # print("")
	# # summ = 0
	# # print("INTERSECTIONS")
	# # for i in ress:

	# # 	elemID = i[0]
	# # 	clustersaa = list(i[1][0])
	# # 	clustersbb = list(i[1][1])
	# # 	print(elemID)
	# # 	print("\t",periods_[0] ,":", clustersaa )
	# # 	print("\t",periods_[1] ,":", clustersbb )
	# # 	# print("\t\t", len(clustersaa) ,"x", len(clustersbb) )
	# # 	mult = len(clustersaa)*len(clustersbb)
	# # 	summ += mult
	# # 	print("\t\t\t", mult )
	# # 	print("")

	# # print( "\t","dacha raw:", summ)
	# # print("")
	# # print("")
	# # print( "|FI|",periods_[0],":", len_FIaa)
	# # print( "|FI|",periods_[0],":", len_FIbb)
	# # print( "\tcartesian product:", len_FIaa*len_FIbb)

	# print("")
	# print("")
	# print("----join_terms----")

	join_terms = aa.join( bb )
	# ress = join_terms.collect()
	# for i in ress:
	# 	print(i)
	# 	clustersaa = list(i[1][0])
	# 	clustersbb = list(i[1][1])
	# 	print("\t",periods_[0] ,":", clustersaa )
	# 	print("\t",periods_[1] ,":", clustersbb )
	# 	print("")


	cartesian = join_terms.map( lambda x : list(itertools.product( x[1][0] , x[1][1] )) )
	cartesian = cartesian.flatMap(lambda x: x).groupBy(lambda x: x).map(lambda x : x[0])

	# print("")
	# print("")
	# print("----cartesian.map----")
	getFIaa = FIaa.collectAsMap()
	getFIbb = FIbb.collectAsMap()

	pairs = cartesian.map( lambda r :  (r[0],r[1],set(getFIaa[r[0]].items), set(getFIbb[r[1]].items) )  )
	# for i in pairs.collect():
	# 	print(i)

	# print("")
	# print("")
	# print("----jaccard_distances----")
	jaccard_distances = pairs.map( lambda x: utls.jaccard_idx( x )  )
	jaccard_distances = jaccard_distances.filter( lambda x: x[0]>0 ).map( lambda x : ( x[0] ,str(periods_[0])+"c"+str(x[1]) , str(periods_[1])+"c"+str(x[2]) ) )
	
	for i in jaccard_distances.collect():
		print( i )






DO_ = {
	"cartesian-print" : test_cartesianproduct,
	"read-jaccs" : reading_jaccs,
	"lala" : lala,
	"interrdd" : interRDD_join,
	"workflow" : test_workflow,
	"mem" : test_newstruct,
}

DO_[TEST_CASE]()
